/** @preserve
  * package: sweetalert2-react-content v0.3.1
  * file: dist/sweetalert2-react-content.cjs.js
  * homepage: https://github.com/sweetalert2/sweetalert2-react-content#readme
  * license: MIT
  **/
'use strict';

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var swal = _interopDefault(require('sweetalert2'));
var React = _interopDefault(require('react'));
var ReactDOM = _interopDefault(require('react-dom'));

var mounts = [{
  key: 'title',
  getter: function getter(swal$$1) {
    return swal$$1.getTitle();
  }
}, {
  key: 'html',
  getter: function getter(swal$$1) {
    return swal$$1.getContent();
  }
}, {
  key: 'confirmButtonText',
  getter: function getter(swal$$1) {
    return swal$$1.getConfirmButton();
  }
}, {
  key: 'cancelButtonText',
  getter: function getter(swal$$1) {
    return swal$$1.getCancelButton();
  }
}, {
  key: 'footer',
  getter: function getter(swal$$1) {
    return swal$$1.getFooter();
  }
}];

var noop = function noop() {};

function withReactContent() {
  var parentSwal = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : swal;

  var argsToParams = function argsToParams(args) {
    if (React.isValidElement(args[0]) || React.isValidElement(args[1])) {
      var params = {};['title', 'html', 'type'].forEach(function (name, index) {
        if (args[index] !== undefined) {
          params[name] = args[index];
        }
      });
      return params;
    } else {
      return parentSwal.argsToParams(args);
    }
  };

  var fn = function fn() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    var params = Object.assign({}, argsToParams(args)); // safe to mutate this

    params.onOpen = params.onOpen || noop;
    params.onClose = params.onClose || noop;

    var _loop = function _loop(key, getter) {
      if (React.isValidElement(params[key])) {
        var reactElement = params[key];
        params[key] = ' ';

        var domElement = void 0;

        var childOnOpen = params.onOpen;
        params.onOpen = function () {
          domElement = getter(parentSwal);
          ReactDOM.render(reactElement, domElement);
          childOnOpen();
        };

        var childOnClose = params.onClose;
        params.onClose = function () {
          childOnClose();
          ReactDOM.unmountComponentAtNode(domElement);
        };
      }
    };

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = mounts[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var _ref = _step.value;
        var key = _ref.key;
        var getter = _ref.getter;

        _loop(key, getter);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }

    return parentSwal(params);
  };

  return Object.assign(fn, parentSwal, { argsToParams: argsToParams });
}

module.exports = withReactContent;
//# sourceMappingURL=sweetalert2-react-content.cjs.js.map
